// code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
using System;

namespace RedBlackTrees {
  public class BsTreeNode<K, V> : SimpleNode where K : IComparable<K> {

    public BsTreeNode(K key, V value) {
      this.key = key;
      this.value = value;
    }

    public IBinaryNode Advance(K key) {
      int compareResult = key.CompareTo(Key);
      if (compareResult == 0) return this;
      if (compareResult < 0) return Left;
      return Right;
    }

    private K key;
    public K Key {
      get { return key; }
      set { key = value; }
    }

    private V value;
    public V Value {
      get { return value; }
      set { this.value = value; }
    }
  }
}
