// code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
using System;
using System.Drawing;

namespace RedBlackTrees {
  public class BsTreeNodePainter<K, V> : SimpleNodePainter where K : IComparable<K> {
    public BsTreeNodePainter(Graphics g, float unit) : base(g, unit) { }

    protected override void DrawData(IBinaryNode node, int number, RectangleF nodeRect) {
      nodeRect.Offset(0.2f, 0.1f);
      BsTreeNode<K, V> charNode = node as BsTreeNode<K, V>;
      if (charNode != null)
        surface.DrawString(charNode.Key.ToString(), font, fontBrush, nodeRect);
    }
  }
}
